import requests
from enum import Enum

class Attribute_model(Enum):
    BASIC = requests.get('http://localhost:8080/values?concept%20name=Cookery&attribute%20name=Basic').json().values()[0]['Basic']
    CARBS = requests.get('http://localhost:8080/values?concept%20name=Cookery&attribute%20name=Carbs').json().values()[0]['Carbs']
    CASEID = None
    DRINKS = requests.get('http://localhost:8080/values?concept%20name=Cookery&attribute%20name=Drinks').json().values()[0]['Drinks']
    FISH = requests.get('http://localhost:8080/values?concept%20name=Cookery&attribute%20name=Fish').json().values()[0]['Fish']
    FRUIT = requests.get('http://localhost:8080/values?concept%20name=Cookery&attribute%20name=Fruit').json().values()[0]['Fruit']
    MEAT = requests.get('http://localhost:8080/values?concept%20name=Cookery&attribute%20name=Meat').json().values()[0]['Meat']
    MILK = requests.get('http://localhost:8080/values?concept%20name=Cookery&attribute%20name=Milk').json().values()[0]['Milk']
    MINOR_INGREDIENT = requests.get('http://localhost:8080/values?concept%20name=Cookery&attribute%20name=Minor%20Ingredient').json().values()[0]['Minor Ingredient']
    OIL_AND_FAT = requests.get('http://localhost:8080/values?concept%20name=Cookery&attribute%20name=Oil%20and%20Fat').json().values()[0]['Oil and Fat']
    SPICE_AND_HERB = requests.get('http://localhost:8080/values?concept%20name=Cookery&attribute%20name=Spice%20and%20Herb').json().values()[0]['Spice and Herb']
    SUPPLEMENT = requests.get('http://localhost:8080/values?concept%20name=Cookery&attribute%20name=Supplement').json().values()[0]['Supplement']
    TITLE = None
    VEGETABLE = requests.get('http://localhost:8080/values?concept%20name=Cookery&attribute%20name=Vegetable').json().values()[0]['Vegetable']

    @staticmethod
    def get_caseid_column_number():
        return 2

    @staticmethod
    def get_title_column_number():
        return 12

    def get_column_number(self):
        if self == Attribute_model.BASIC:
            return 0
        if self == Attribute_model.CARBS:
            return 1
        if self == Attribute_model.CASEID:
            return 2
        if self == Attribute_model.DRINKS:
            return 3
        if self == Attribute_model.FISH:
            return 4
        if self == Attribute_model.FRUIT:
            return 5
        if self == Attribute_model.MEAT:
            return 6
        if self == Attribute_model.MILK:
            return 7
        if self == Attribute_model.MINOR_INGREDIENT:
            return 8
        if self == Attribute_model.OIL_AND_FAT:
            return 9
        if self == Attribute_model.SPICE_AND_HERB:
            return 10
        if self == Attribute_model.SUPPLEMENT:
            return 11
        if self == Attribute_model.TITLE:
            return 12
        if self == Attribute_model.VEGETABLE:
            return 13

class myCBRModel():

    # Matches all ingredients if possible to values in the mycbr model
    # Returns two lists with unique values: One list with ingredients that match and one list with ingredients that does not match
    @staticmethod
    def match_ingredients_with_mycbr_model(ingredients):
        # Create sets so we only get the unique values
        ingredients_with_match = set()
        ingredients_without_match = set()
        for ingredient in ingredients:
            if str(ingredient) == "":
                continue
            else:
                match = myCBRModel.match_ingredient(ingredient)
                if match == -1:
                    ingredients_without_match.add(str(ingredient))
                else:
                    ingredients_with_match.add(str(ingredient))
        return ingredients_with_match, ingredients_without_match

    #Returns attribute id (column number) if match on that attribute
    #Returns -1 if no match on none of the attribute models
    @staticmethod
    def match_ingredient(ingredient):
        for name, member in Attribute_model.__members__.items():
            attribute_model = member.value
            if attribute_model is None:
                continue
            for attribute_ingredient in attribute_model:
                if attribute_ingredient.encode("utf-8").lower() == ingredient.lower():
                    return int(Attribute_model.get_column_number(member))
        return -1



