from Model import myCBRModel
from XML import XML
from sets import Set

class rule_generator:
    def __init__(self):
        self.print_process = True
        self.xml_file = XML(input_file='resources/sandwich-recipes.xml', print_process=False)
        self.xml_recipes = self.xml_file.get_recipes()
        self.ingredient_with_category = dict()
        self.main()
        # self.print_create_rules_content()

    def main(self):
        unique_xml_ingredients = self.xml_file.get_unique_ingredients()
        match, no_match = myCBRModel.match_ingredients_with_mycbr_model(unique_xml_ingredients)
        # Make sure all ingredients are matched
        if len(no_match) == 0:
            self.create_category_ingredient_dictionary(unique_xml_ingredients)
        else:
            print(str(len(no_match)) + " ingredients are not matched with myCBR")

    def create_category_ingredient_dictionary(self, ingredients):
        print(str(len(ingredients)) + " unique ingredients in XML file")
        for ing in ingredients:
            category = myCBRModel.match_ingredient(ing)
            if category in self.ingredient_with_category:
                self.ingredient_with_category[category].append(ing)
            else:
                self.ingredient_with_category[category] = [ing]

    def print_create_rules_content(self):
        for key, value in self.ingredient_with_category.items():
            print("")
            print("# " + str(key))
            for ingredient in value:
                print('["'+ingredient+'","",""],')

    def create_rules(self):
        rules = [
            # 0
            ["brown sugar","","",""],
            ["egg","","",""],

            # 4
            ["lemon juice","","",""],

            # 5
            ["crab","","",""],
            ["salmon","","",""],
            ["smoked salmon","","",""],
            ["crabmeat","","",""],
            ["shrimp","","",""],

            # 6
            ["lemon","","",""],
            ["avocado","","",""],
            ["lime","","",""],
            ["mango","","",""],
            ["pineapple","","",""],

            # 7
            ["chicken","","",""],
            ["turkey","","",""],
            ["ham","","",""],
            ["goat","","",""],
            ["parma ham","","",""],
            ["bacon","","",""],
            ["chicken breast","","",""],

            # 9
            ["cream","","",""],
            ["cream cheese","","",""],
            ["low-fat cream","","",""],
            ["gruyere","","",""],
            ["yogurt","","",""],

            # 10
            ["batavia","","",""],
            ["hummus","","",""],

            # 11
            ["olive oil","","",""],
            ["butter","","",""],
            ["extra virgin olive oil","","",""],

            # 12
            ["pita bread","","",""],
            ["baguette","","",""],
            ["tofu","","",""],
            ["bagel","","",""],
            ["bread","","",""],
            ["wholemeal pain de mie","","",""],
            ["pain de mie","","",""],

            # 13
            ["dill","","",""],
            ["garlic","","",""],
            ["green pepper","","",""],
            ["mint","","",""],
            ["parsley","","",""],
            ["curry powder","","",""],
            ["basil","","",""],
            ["pepper","","",""],
            ["chili powder","","",""],
            ["black pepper","","",""],
            ["chive","","",""],
            ["salt","","",""],

            # 14
            ["tzatziki","","",""],
            ["soy sauce","","",""],
            ["mayonnaise","","",""],
            ["mustard","","",""],
            ["tabasco sauce","","",""],
            ["white wine vinegar","","",""],
            ["ketchup","","",""],
            ["pesto","","",""],

            # 17
            ["radish","","",""],
            ["red onion","","",""],
            ["arugula","","",""],
            ["lettuce","","",""],
            ["beet","","",""],
            ["celery","","",""],
            ["salad green","","",""],
            ["cucumber","","",""],
            ["cabbage","","",""],
            ["lamb's lettuce","","",""],
            ["tomato","","",""],
            ["onion","","",""],
            ["cherry tomato","","",""],
        ]

    # Print function that only prints if self.print_process is set to True
    def pp(self, text):
        if self.print_process:
            print(text)

rule_generator()