package no.ntnu.mycbr;

import de.dfki.mycbr.core.Project;
import de.dfki.mycbr.core.model.Concept;
import no.ntnu.mycbr.rest.App;
import no.ntnu.mycbr.rest.adaptation.rules.RulesInit;

public class CBREngine {


   /* Get actual class name to be printed on */

	// set path to myCBR projects
	private static String data_path = System.getProperty("user.dir") + "/src/main/resources/";
	/* project specific: NewExampleProject*/
	// name of the project file
	private static String projectName = "myCBRproject.prj";
	// name of the central concept
	private static String conceptName = "Cookery";

	// name of the csv containing the instances
	private static String csv = "model-sandwich.csv";
	// set the separators that are used in the csv file
	private static String columnseparator = ";";

	private static String multiplevalueseparator = ",";

	private static RulesInit rules;

	// name of the case base that should be used; the default name in myCBR is CB_csvImport
	private static String casebase = "Sandwich";
	// Getter for the ConceptName meta data
	public static String getCaseBase() {
		return casebase;
	}

	public static void setCasebase(String casebase) {
		CBREngine.casebase = casebase;
	}

	public static String getProjectName() {
		return projectName;
	}

	public static void setProjectName(String projectName) {
		CBREngine.projectName = projectName;
	}

	public static String getConceptName() {
		return conceptName;
	}

	public static Concept getConcept() { return  App.getProject().getConceptByID(conceptName); }

	public static Project getProject() { return App.getProject(); }

	public static void setConceptName(String conceptName) {
		CBREngine.conceptName = conceptName;
	}

	public static String getCsv() {
		return csv;
	}

	public static void setCsv(String csv) {
		CBREngine.csv = csv;
	}

	public static void setRules(RulesInit rules) { CBREngine.rules = rules;}
	public static RulesInit getRules() { return rules;}

	/**
	 * This methods creates a myCBR project and loads the project from a .prj file
	 */
	public Project createProjectFromPRJ(){

		System.out.println("Trying to load prj file with : "+data_path.trim()+ " "+projectName+" "+conceptName+" ");

		Project project = null;

		try{
			project = new Project(data_path + projectName);

			// Sehr wichtig hier das Warten einzubauen, sonst gibts leere
			// NewRetrieval Results, weil die Faelle noch nicht geladen sind wenn das
			// Erste NewRetrieval laueft
			while (project.isImporting()){
				Thread.sleep(1000);
				System.out.print(".");
			}
			System.out.print("\n");    //console pretty print
			// System.out.print("cb: " project.getCaseBases().get(CBREngine.getCaseBase()).getName());    //console pretty print
		}
		catch(Exception ex){

			System.out.println("Error when loading the project");
		}
		return project;
	}


	/**
	 * This methods creates an EMPTY myCBR project.
	 * The specification of the project's location and according file names has to be
	 * done at the beginning of this class.
	 * @return ConceptName adaptedInstance containing model, sims and cases (if available)
	 */
	public Project createemptyCBRProject(){

		Project project = null;
		try {
			// load new project
			project = new Project(data_path+projectName);
			// create a concept and get the main concept of the project;
			// the name has to be specified at the beginning of this class
			while (project.isImporting()){
				Thread.sleep(1000);
				System.out.print(".");
			}
			System.out.print("\n");    //console pretty print
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return project;
	}

	public Project createTestCBRProject(){

		Project project = null;
		CBREngine.conceptName = "TestConcept";

		try {
			// load new project
			project = new Project(data_path+ "myCBRTestProject.prj");
			// create a concept and get the main concept of the project;
			// the name has to be specified at the beginning of this class
			while (project.isImporting()){
				Thread.sleep(1000);
				System.out.print(".");
			}
			System.out.print("\n");    //console pretty print
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return project;
	}
}