package no.ntnu.mycbr.rest;

import de.dfki.mycbr.core.Project;
import de.dfki.mycbr.core.casebase.Attribute;
import de.dfki.mycbr.core.casebase.Instance;
import de.dfki.mycbr.core.model.AttributeDesc;
import no.ntnu.mycbr.CBREngine;

import java.util.HashMap;
import java.util.Map;

public class Case {

    private HashMap<String, String> casecontent;

    public Case(String caseID) {
        casecontent = new HashMap<>();

        Project project = App.getProject();
        de.dfki.mycbr.core.model.Concept myConcept = project.getConceptByID(CBREngine.getConceptName());
        Instance aInstance = myConcept.getInstance(caseID);

        if (aInstance == null) {
            System.out.println("Case with name " + caseID + " does not exist.");
        } else {
            HashMap<AttributeDesc, Attribute> atts = aInstance.getAttributes();

            for (Map.Entry<AttributeDesc, Attribute> entry : atts.entrySet()) {
                AttributeDesc attDesc = entry.getKey();
                Attribute att = entry.getValue();
                String value = att.getValueAsString();
                value.trim();

                if (value.compareTo("_undefined_") != 0 && value.compareTo("") != 0) {
                    this.casecontent.put(attDesc.getName(), att.getValueAsString());
                }
            }
        }

    }

    public HashMap<String, String> getCase() {
        return casecontent;
    }
}
