package no.ntnu.mycbr.rest;


import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import org.json.simple.parser.ParseException;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class QuizAnswer {

    private String returnMessage;

    QuizAnswer(String casename, Boolean createdByAi, String answer) {

        JSONParser parser = new JSONParser();
        JSONObject allRecipesJSONObject;

        try {
            String caseNameText = "caseName";
            String createdByAiText = "createdByAI";
            String correctGuessesText = "correctGuesses";
            String wrongGuessesText = "wrongGuesses";

            String fileName = "./src/main/resources/quiz-answers.json";

            allRecipesJSONObject = (JSONObject) parser.parse(new FileReader(fileName));
            JSONArray recipesArray = (JSONArray) allRecipesJSONObject.get("recipes");

            JSONObject recipeJSONObject = new JSONObject();
            JSONObject newRecipeJSONObject = new JSONObject();

            for (Object recipeJavaObject : recipesArray) {
                recipeJSONObject = (JSONObject) recipeJavaObject;

                // If there already exist an object for the given case; modify it
                if (casename.equals(recipeJSONObject.get(caseNameText))) {

                    newRecipeJSONObject.put(caseNameText, casename);
                    newRecipeJSONObject.put(createdByAiText, createdByAi);
                    if ("correct".equals(answer)) {
                        newRecipeJSONObject.put(correctGuessesText, (Long) recipeJSONObject.get(correctGuessesText) + 1);
                        newRecipeJSONObject.put(wrongGuessesText, recipeJSONObject.get(wrongGuessesText));
                    } else if ("wrong".equals(answer)) {
                        newRecipeJSONObject.put(correctGuessesText, recipeJSONObject.get(correctGuessesText));
                        newRecipeJSONObject.put(wrongGuessesText, (Long) recipeJSONObject.get(wrongGuessesText) + 1);
                    }
                    break;
                }
            }

            if (newRecipeJSONObject.containsKey(caseNameText)) {

                // If the new object is modified, remove the old and add the new to the list
                recipesArray.remove(recipeJSONObject);
                recipesArray.add(newRecipeJSONObject);
            } else {

                // If not, create a new object for this case
                newRecipeJSONObject.put(caseNameText, casename);
                newRecipeJSONObject.put(createdByAiText, createdByAi);
                if ("correct".equals(answer)) {
                    newRecipeJSONObject.put(correctGuessesText, 1);
                    newRecipeJSONObject.put(wrongGuessesText, 0);
                } else if ("wrong".equals(answer)) {
                    newRecipeJSONObject.put(correctGuessesText, 0);
                    newRecipeJSONObject.put(wrongGuessesText, 1);
                }
                recipesArray.add(newRecipeJSONObject);
            }

            // Replace the old objects with the modified/added objects
            allRecipesJSONObject.replace("recipes", recipesArray);
            try (FileWriter answerFile = new FileWriter(fileName)) {
                answerFile.write(allRecipesJSONObject.toJSONString());
            } catch (IOException e) {
                e.printStackTrace();
            }
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ParseException e) {
            e.printStackTrace();
        }

        returnMessage = "success";
    }

    String addQuizAnswer() {
        return returnMessage;
    }
}
