package no.ntnu.mycbr.rest;

import de.dfki.mycbr.core.Project;
import de.dfki.mycbr.core.model.*;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;

public class ValueRange {

    private HashMap<String, Object> attributes;

    public ValueRange(String concept, String attributeName) {
        attributes = new HashMap<String, Object>();

        // create a concept and get the main concept of the project;
        Project project = App.getProject();
        de.dfki.mycbr.core.model.Concept myConcept = project.getConceptByID(concept);

        AttributeDesc attdesc = myConcept.getAttributeDesc(attributeName);

        if (attdesc.getClass().getSimpleName().equalsIgnoreCase("FloatDesc")){
            FloatDesc aFloatAtt = (FloatDesc) attdesc;
            Set<Float> range = new HashSet<>();
            range.add(aFloatAtt.getMin());
            range.add(aFloatAtt.getMax());
            attributes.put(attdesc.getName(),range);
        }
        if (attdesc.getClass().getSimpleName().equalsIgnoreCase("IntegerDesc")){
            IntegerDesc aIntegerAtt = (IntegerDesc) attdesc;
            Set<Integer> range = new HashSet<>();
            range.add(aIntegerAtt.getMin());
            range.add(aIntegerAtt.getMax());
            attributes.put(attdesc.getName(),range);
        }
        if (attdesc.getClass().getSimpleName().equalsIgnoreCase("DoubleDesc")){
            DoubleDesc aIntegerAtt = (DoubleDesc) attdesc;
            Set<Double> range = new HashSet<>();
            range.add(aIntegerAtt.getMin());
            range.add(aIntegerAtt.getMax());
            attributes.put(attdesc.getName(),range);
        }
        if (attdesc.getClass().getSimpleName().equalsIgnoreCase("SymbolDesc")){
            SymbolDesc aSymbolAtt = (SymbolDesc) attdesc;
            attributes.put(attdesc.getName(),aSymbolAtt.getAllowedValues());
        }
        else {
            attributes.put(attdesc.getName(),"n/a");
        }
    }

    public HashMap<String, Object> getValueRange() {

        return attributes;
    }

}