package no.ntnu.mycbr.rest.adaptation;

import de.dfki.mycbr.core.casebase.Attribute;
import de.dfki.mycbr.core.casebase.Instance;
import de.dfki.mycbr.core.model.AttributeDesc;
import de.dfki.mycbr.core.model.Concept;
import de.dfki.mycbr.core.similarity.Similarity;
import de.dfki.mycbr.util.Pair;
import no.ntnu.mycbr.rest.adaptation.helpClasses.Operations;
import no.ntnu.mycbr.rest.adaptation.helpClasses.Print;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class PostAdaptationOriginal {
    // Post adapatation for original instances

    public static List<Pair<Instance, Similarity>> filterOriginalRecipes(Concept myConcept, Instance queryUndesired, List<Pair<Instance, Similarity>> retrievedResults) {
        List<Pair<Instance, Similarity>> resultsThatDoesNotSatisfyUndesired = new ArrayList<Pair<Instance, Similarity>>();

        Print.printFiltering("");
        Print.printFiltering("----------------------------------------------");
        Print.printFiltering("");

        // Loop through each retrieved original adaptedInstance
        for (Pair<Instance, Similarity> result : retrievedResults) {
            Instance originalInstance = result.getFirst();

            // Loop through each attribute
            for (Map.Entry<String, AttributeDesc> entry : myConcept.getAttributeDescs().entrySet()) {
                AttributeDesc attrDesc = entry.getValue();

                Attribute undesiredQueryAttribute = queryUndesired.getAttForDesc(attrDesc);
                Attribute recipeAttribute = originalInstance.getAttForDesc(attrDesc);

                List<String> recipeAttributeAsList = Operations.getAttributeAsSingleValues(recipeAttribute);
                List<String> queryAttributeAsList = Operations.getAttributeAsSingleValues(undesiredQueryAttribute);

                // If undesired query Attribute has requirements
                if (Operations.attributeContainsValues(undesiredQueryAttribute)) {
                    // if recipeAttribute contains any queryAttribute value -> recipe should be removed from ResultList
                    for (String undesiredIngredient : queryAttributeAsList) {
                        if (recipeAttributeAsList.contains(undesiredIngredient)) {
                            resultsThatDoesNotSatisfyUndesired.add(result);
                            Print.printFiltering(originalInstance.getName() + " was filtered from resultList (undesired query not satisfied)");
                        }
                    }
                }
            }
        }

        for (Pair<Instance, Similarity> resultThatDoesNotSatisfy : resultsThatDoesNotSatisfyUndesired) {
            retrievedResults.remove(resultThatDoesNotSatisfy);
        }
        return retrievedResults;
    }
}
