package no.ntnu.mycbr.rest.adaptation.helpClasses;

import java.util.Arrays;
import java.util.List;
import de.dfki.mycbr.core.model.AttributeDesc;

public class Settings {
    private static List<String> attributesThatShouldNotBeModified = Arrays.asList("CaseId", "Title");
    private static List<String> taxonomiesThatShouldNotBeConsidered = Arrays.asList("CaseId", "Title", "Minor Ingredient");

    // case base retrieval
    public static int numberOfRetrievedCases = 20;

    // rules location
    public static String substitutionFileName="./src/main/resources/rules/substitutionRules.txt";
    public static String additionFileName="./src/main/resources/rules/simplyAddingRules.txt";
    public static String suitableIngredientsFilename="./src/main/resources/rules/suitableIngredientsRules.txt";
    public static String removalFileName="./src/main/resources/rules/simplyRemoveRules.txt";
    public static String titleFileName="./src/main/resources/rules/titleRules.txt";

    // PRINTS
    // PRE adaptation
    public static Boolean printManualRetrieval = false;
    public static Boolean printFilteredOriginalInstances = false;
    public static Boolean printAddUnwantedIngredientChildren = false;
    public static Boolean printRules = false;

    // Adaptation process
    public static Boolean printOneProcess = false;
    public static Boolean printNonValidAdaptedInstances = false;
    public static Boolean printZeroAdaptedInstances = false;

    public static Boolean printHistory = false;
    public static Boolean printStatistics = false;

    public static Boolean printGlobalStatistics = false;
    public static Boolean printFinalNumbers = false;

    // POST adaptation
    public static Boolean printRemoveEqualRecipesProcess = false;
    public static Boolean printPunishAdaptedRecipes = false;
    public static Boolean printAdaptationEvaluation = false;

    // How many "points" one get per modification. Is added so that adaptation threshold is not surpassed
    public static int additionRulePoints = 1;
    public static int removalRulePoints = 1;
    public static int substitutionRulePoints = 2;
    public static int similaritySubstitutionPoints = 3;

    public static List<String> getAttributesThatShouldNotBeModified() {
        return attributesThatShouldNotBeModified;
    }
    public static List<String> getTaxonomiesThatShouldNotBeConsidered() { return taxonomiesThatShouldNotBeConsidered; }

    //public static double getThresholdForDesiredIngredientSubstitution() { return similaritySubstitutionThreshold; }

    public static double getThresholdForIngredientSubstitution(AttributeDesc attrDesc) {
        String name = attrDesc.getName();
        if (name.equals("Basic")) {return 0.49;}
        if (name.equals("Carbs")) {return 0.49;}
        if (name.equals("Drinks")) {return 0.70;}
        if (name.equals("Fish")) {return 0.20;}
        if (name.equals("Fruit")) {return 0.70;}
        if (name.equals("Meat")) {return 0.70;}
        if (name.equals("Milk")) {return 0.70;}
        if (name.equals("Oil and Fat")) {return 0.49;}
        if (name.equals("Spice and Herb")) {return 0.49;}
        if (name.equals("Supplement")) {return 0.70;}
        if (name.equals("Vegetable")) {return 0.49;}
        else { return 0.49; }
    }

}
