package no.ntnu.mycbr.rest.adaptation.rules;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;

public class Rule {
    public HashMap<String, HashSet<String>> requirements;

    // Returns true if one ingredient per MAIN requirement is in recipe
    protected Boolean mainRequirementsAreSatisfied(HashSet<String> allIngredients) {
        if (requirements.size()==0) {
            return true;
        }
        for (Map.Entry<String, HashSet<String>> entry : requirements.entrySet()) {
            Boolean mainRequirementIsSatisfied = false;
            HashSet<String> mainRequirementPlusChildren = entry.getValue();
            for (String req : mainRequirementPlusChildren) {
                if (allIngredients.contains(req)) {
                    // If allIngredients contains one of the required ingredients on this main requirement, set true
                    mainRequirementIsSatisfied = true;
                }
            }
            // If some of the main requirements are not satisfied, requirements are not satisfied, and return false
            if (!mainRequirementIsSatisfied) {
                return false;
            }
        }
        return true;
    }
}
