import {NgModule} from "@angular/core";
import {BrowserModule} from "@angular/platform-browser";
import {RouterModule} from "@angular/router";
import {HttpModule, JsonpModule} from "@angular/http";
import {FormsModule} from "@angular/forms";

import {AppComponent} from "./app.component";
import {NavigationComponent} from "./shared/navigation.component";
import {HomeComponent} from "./components/home/home.component";
import {AboutComponent} from "./components/about/about.component";
import {PageNotFoundComponent} from "./components/pagenotfound/pagenotfound.component";
import {QuizComponent} from "./components/quiz/quiz.component";

@NgModule({
  imports: [
    BrowserModule,
    RouterModule.forRoot([
      {path: 'about', component: AboutComponent},
      {path: 'botornot', component: QuizComponent},
      {path: '', component: HomeComponent},
      {path: '**', component: PageNotFoundComponent}
    ]),
    HttpModule,
    JsonpModule,
    FormsModule
  ],
  declarations: [
    AppComponent,
    HomeComponent,
    QuizComponent,
    AboutComponent,
    PageNotFoundComponent,
    NavigationComponent
  ],
  bootstrap: [AppComponent]
})
export class AppModule {
}
