/**
 * Created by martheoynes on 07.12.2016.
 */

export class Case {

  id: string;
  attributeDict: KeyValuePair[];
  recipe: Recipe;
  title: string;
  adapted: boolean;
  adaptations: KeyValuePair[];
  queryParentIngredientChildList: KeyValuePair[];
  queryChildIngredientParentList: KeyValuePair[];
  missingIngredients: string[];

  addMissingIngredients(missingIngredients: string[]) {
    // Only adds missing ingredients that are not a key in queryParentIngredientChildList
    let queryParentIngredientChildListKeys: string[] = [];
    for (let queryParentIngredientChild of this.queryParentIngredientChildList) {
      queryParentIngredientChildListKeys.push(queryParentIngredientChild.key);
    }

    let queryChildIngredientParentListKeys: string[] = [];
    for (let queryChildIngredientParent of this.queryChildIngredientParentList) {
      queryChildIngredientParentListKeys.push(queryChildIngredientParent.key);
    }

    let actualMissingIngredients: string[] = [];
    for (let missingIngredient of missingIngredients) {
      if (queryParentIngredientChildListKeys.indexOf(missingIngredient) === -1
        && queryChildIngredientParentListKeys.indexOf(missingIngredient) === -1) {
        actualMissingIngredients.push(missingIngredient);
      }
    }
    this.missingIngredients = actualMissingIngredients;
  }

  setAttributes(attributeDict: KeyValuePair[]) {
    for (let j = 0; j < attributeDict.length; j++) {
      if (attributeDict[j].key === 'CaseId') {
        this.id = attributeDict[j].value;
      }
      if (attributeDict[j].key === 'Title') {
        this.title = attributeDict[j].value;
      }
    }
    this.attributeDict = attributeDict;
  }

  getScore() {
    return Math.round(this.score * 100).toFixed(0);
  }

  constructor(public name: string,
              public score: number) {
  }

}

export class Recipe {
  id: string;
  ingredients: KeyValuePair[];
  preparationsteps: string[];
  createdByAI: boolean = false;
}

// Class to be used for several Dictionary/KeyValuePair purposes
export class KeyValuePair {

  constructor(public key: string,
              public value: string) {
  }
}
