/**
 * Created by martheoynes on 09.05.2017.
 */

import {Injectable} from "@angular/core";
import {Http, Response, URLSearchParams} from "@angular/http";
import {Observable} from "rxjs/Observable";
import {AppSettings} from "../../appSettings";

import "rxjs/add/operator/map";
import "rxjs/add/operator/catch";

@Injectable()

export class QuizService {

  private static handleError(error: any) {
    let errMsg = (error.message) ? error.message : error.status ? `${error.status} - ${error.statusText}` : 'Server error';
    console.error(errMsg);
    return Observable.throw(errMsg);
  }

  constructor(private http: Http) {
  }

  submitAnswer(caseName: string, createdByAi: boolean, answer: string): Observable<string[]> {
    let params: URLSearchParams = new URLSearchParams();
    params.set('createdByAi', createdByAi.toString());
    params.set('casename', caseName);
    params.set('answer', answer);

    return this.http.get(AppSettings.BACKEND_URL + '/submitquizanswer', {search: params})
      .map((response: Response) => {
        return response;
      })
      .catch(QuizService.handleError);
  }
}
